#-*- coding: UTF-8 -*-

#**********************************************
# R2spec 
#
# Class file for the class Packager
#
# Distributed under License GPLv3 or later
# You can find a copy of this license on the website
# http://www.gnu.org/licenses/gpl.html
#
#**********************************************
import sys, os, re

class Packager:
    '''
    Packager class.
      Creates and handle the object Packager
    '''

    def __init__(self):
        ''' Creates the object of class Packager and set the attributes '''
        self.name = None
        self.email = None
        self.bioc = None
    
    def setName(self,name):
        ''' Set the name of the packager '''
        self.name = name

    def setEmail(self, email):
        ''' Set the Email of the packager '''
        self.email = email

    def readConfFile(self, bioc):
        '''
        Reads the file /etc/R2spec.conf and set the name
        and email of the packager and the version on Bioconductor is needed
        '''
        # Default config file
        conf_file = '/etc/R2spec.conf'
        
        # Check if there is a ~/.R2spec.conf which overrides the defaulf file
        if os.path.isfile ( os.path.expanduser("~" + "/.R2spec.conf") ):
            conf_file =  os.path.expanduser("~" + "/.R2spec.conf")
        
        try:
            conf_size = os.path.getsize ( conf_file )
        except Exception, err:
            conf_size = 0
        if conf_size is not 0:
            f= open ( conf_file )
            conf_file = f.read()
            f.close()

            # find the name of the packager
            namemotif = re.compile('Packager name:(.*)')
            try:
                name = namemotif.findall(conf_file)[0]
                self.name = name.strip()
            except IndexError, err:
                self.name = ""

            # find the mail of the packager
            mailmotif = re.compile('Packager email:(.*)')
            try:
                mail = mailmotif.findall(conf_file)[0]
                self.email = mail.strip()
            except IndexError, err:
                self.email = ""

            #If bioc=true read the get the bioc version defined in the configuration file
            if bioc:
                biocmotif = re.compile('Bioconductor release:(.*)')
                try:
                    bioc = biocmotif.findall(conf_file)[0]
                    self.bioc = bioc.strip()
                except IndexError, err:
                    self.bioc = ""
    
